package JSPservletPkg;
import javax.servlet.http.*;
/**
 * PageBox API implementation.
 * <p>Changes:<ul>
 * <li>Version 1.0.4: Resin 1.2.5 support.</li></ul></p>
 * <p>Copyright (c) 2000-2001 Alexis Grandemange</p>
 * <pre>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; version
 * 2.1 of the License.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 * </pre>
 * <p>I included a copy of the GNU Lesser General Public License lesser.txt
 * in this directory.</p>
 * <p>alexis.grandemange@pagebox.net</p>
 * @author  Alexis Grandemange
 * @version 1, 0, 4
 */
public class PageBoxAPI {
  /** Relevant JSPhandler. */
  JSPhandler handler = null;
  /** Path to the current servlet. */
  String pathInfo = null;
  /**
   * Constructor.
   * @param     request HttpServletRequest.
   */
  public PageBoxAPI(HttpServletRequest request) {
    String contextPath = JSPservlet.getPathInfo(request, true);
    if (contextPath != null)
      handler = (JSPhandler)JSPservlet.JSPhandlers.get(contextPath.toLowerCase());
	  pathInfo = JSPservlet.getPathInfo(request, false);
  }
  /**
   * Returns the unique identifier of the PageBox.
   */
  public String getID() {
    if (handler != null)
      return handler.ID;
    return null;
  }
  /**
   * Logs a message.
   * @param     msg message to log.
   */
  public void log(String msg) {
    if (handler == null)
      return;
    if (pathInfo != null)
      handler.log.userprint(pathInfo + ":" + msg);
    else
      handler.log.userprint(msg);
  }
}
