package JSPservletPkg;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
/**
 * Log display servlet.
 * <p>Changes:<ul>
 * <li>Version 1.0.4: support for Resin app-dir. Resin 1.2.5 support.</li></ul>
 * <p>Copyright (c) 2000-2001 Alexis Grandemange</p>
 * <pre>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; version
 * 2.1 of the License.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 * </pre>
 * <p>I included a copy of the GNU Lesser General Public License lesser.txt
 * in this directory.</p>
 * <p>alexis.grandemange@pagebox.net</p>
 * @author  Alexis Grandemange
 * @version 1, 0, 4
 */
public class ServletLog extends HttpServlet {
  /** Invoked by Servlet container. */
  public void init(ServletConfig config) throws ServletException {
    super.init(config);
  }
  /**
   * GET request handling.
   * @param     request HttpServletRequest.
   * @param     response HttpServletResponse.
   */
  public void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
    String contextPath = JSPservlet.getPathInfo(request, true);
    if (contextPath.equals(JSPservlet.invokerMapping))
      contextPath = JSPservlet.app_dir_ctx;
    PrintWriter out = new PrintWriter (response.getOutputStream());
    out.println(
      "<html><head><title>log display</title></head><body><h2>log display</h2>");
    // display useful information before first use
    out.println("<p>Context path:" + contextPath + "<br>Path info:" +
      JSPservlet.getPathInfo(request, false) + "</p>");
    if ((JSPservlet.JSPhandlers == null) ||
      !JSPservlet.JSPhandlers.containsKey(contextPath.toLowerCase())) {
      out.println("<p><font color=#DB1260 size=4><i>" + contextPath +
        " handler not created</i></font>");
      out.flush();
      return;
    }
    JSPhandler jh = (JSPhandler)JSPservlet.JSPhandlers.get(
      contextPath.toLowerCase());
    if ((jh.log == null) || (jh.log.logFile == null)) {
      out.println(
        "<p><font color=#DB1260 size=4><i>log not set</i></font></body></html>");
      out.flush();
      return;
    }
    File f = new File(jh.log.logFile);
    if ((f == null) || !f.exists()) {
      out.println(
        "<p><font color=#DB1260 size=4><i>log empty</i></font></body></html>");
      out.flush();
      return;
    }
    out.println("<form  action=ServletLog method=\"GET\">");
    out.println(
"<font face=\"Helvetica\"><input type=\"Submit\" value=\"Clear\" name=\"Clear\"></form>");
    if (request.getParameter("Clear") != null) {
      jh.log.clear();
      out.println(
        "<p><font color=#DB1260 size=4><i>log cleared</i></font></body></html>");
      out.flush();
      return;
    }
    BufferedReader br = new BufferedReader(new InputStreamReader(
      new FileInputStream(f)));
    String ln = null;
    while ((ln = br.readLine()) != null) {
      if (ln.startsWith("ERROR ") || ln.startsWith("EXCEP "))
        out.println("<font color=#DB1260 size=2><b>" + ln + "</b></font></br>");
      else
      if (ln.startsWith("USER "))
        out.println("<font color=green size=2><b>" + ln + "</b></font></br>");
      else
        out.println("<font size=2>" + ln + "</font></br>");
    }
    out.println(
      "<hr>Alexis Grandemange (c) 2000-2001 GNU LGPL 2.1</body></html>");
    out.flush();
  }
  public String getServletInfo() {
    return "JSPservletPkg.ServletLog Information";
  }
}