package JSPservletPkg;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
/**
 * Statistics display servlet.
 * <p>Changes:<ul>
 * <li>Version 1.0.4: Resin 1.2.5 support.</li></ul></p>
 * <p>Copyright (c) 2000-2001 Alexis Grandemange</p>
 * <pre>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; version
 * 2.1 of the License.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 * </pre>
 * <p>I included a copy of the GNU Lesser General Public License lesser.txt
 * in this directory.</p>
 * <p>alexis.grandemange@pagebox.net</p>
 * @author  Alexis Grandemange
 * @version 1, 0, 4
 */
public class ServletStat extends HttpServlet {
  /** Invoked by Servlet container. */
  public void init(ServletConfig config) throws ServletException {
    super.init(config);
  }
  /**
   * GET request handling.
   * @param     request HttpServletRequest.
   * @param     response HttpServletResponse.
   */
  public void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
    String contextPath = JSPservlet.getPathInfo(request, true);
    PrintWriter out = new PrintWriter (response.getOutputStream());
    out.println(
      "<html><head><title>Statistics</title></head><body><h2>Statistics</h2>");
    if ((JSPservlet.JSPhandlers == null) ||
      !JSPservlet.JSPhandlers.containsKey(contextPath.toLowerCase())) {
      out.println("<p><font color=#DB1260 size=4><i>" + contextPath +
        " handler not created</i></font>");
      out.flush();
      return;
    }
    JSPhandler jh = (JSPhandler)JSPservlet.JSPhandlers.get(
      contextPath.toLowerCase());
    Collection classEntries = jh.classEntries.values();
    Properties prop = null;
    String jarName = null;
    if (request.getParameter("statOFF") != null) {
      jh.toStat = false;
      Iterator i = classEntries.iterator();
      while(i.hasNext()) {
        JSPhandler.ClassEntry ce = (JSPhandler.ClassEntry)i.next();
        ce.stat.close();
      }
    } else
    if (request.getParameter("statON") != null) {
      jh.toStat = true;
      Iterator i = classEntries.iterator();
      while(i.hasNext()) {
        JSPhandler.ClassEntry ce = (JSPhandler.ClassEntry)i.next();
        ce.stat.init();
      }
    } else {
      jarName = request.getParameter("jarName");
      if (jarName != null) {
        JSPhandler.ClassEntry ce = (JSPhandler.ClassEntry)
          jh.classEntries.get(jarName);
        prop = ce.stat.prop;
        if (prop != null) {
          String szToClear = (String)request.getParameter("Clear");
          if (szToClear != null)
            prop.clear();
          else {
            Enumeration e = prop.keys();
            out.println("<table border=0 cellspacing=2 cellpadding=2 width=60%>");
            out.println("<tr><td width=20%><font face=\"Helvetica\" size=2>" +
              "<b>Servlet</b></font></td><td width=20%>&nbsp;</td><td width=20%>"
              + "<font face=\"Helvetica\" size=2><b>Invocation number</b></td>" +
              "</font></tr>");
            while(e.hasMoreElements()) {
              String classpath = (String)e.nextElement();
              out.println("<tr><td width=20%><font face=\"Helvetica\" size=2>" +
                classpath + "</font></td><td width=20%>&nbsp;</td><td width=20%>"
                + "<font face=\"Helvetica\" size=2><b>" + prop.get(classpath) +
                "</b></td></font></tr>");
            }
            out.println("</table>");
          }
        }
      }
    }
    out.println("<form  action=ServletStat method=\"GET\">");
    out.println("<table border=0 cellspacing=2 cellpadding=2 width=60%><tr>");
    out.println("<td width=20%><font face=\"Helvetica\"><b>JAR Name :</b>");
    out.println("</td><td width=20%>&nbsp;</td><td width=20%>");
    out.println("<font face=\"Helvetica\"><select name=\"jarName\">");
    Set archs = jh.classEntries.keySet();
    Iterator i = archs.iterator();
    while(i.hasNext()) {
      String option = (String)i.next();
      if ((jarName != null) && option.equals(jarName))
        out.println("<option selected value=\"" + option + "\">" + option);
      else
        out.println("<option value=\"" + option + "\">" + option);
    }
    out.println("</select></font></td></tr><tr>");
    String statsToggle = jh.toStat ? "statOFF" : "statON";
    out.println(
      "<td width=20%><font face=\"Helvetica\"><input type=\"Submit\" value=\"" +
      statsToggle + "\" name=\"" + statsToggle + "\"></td>");
    out.println(
      "<td width=20%><font face=\"Helvetica\"><input type=\"Submit\" value=\"" +
      "Clear\" name=\"Clear\"></td>");
    out.println(
      "<td width=20%><font face=\"Helvetica\"><input type=\"Submit\" value=\"" +
      "List\" name=\"List\"></td></tr><table></form>");
    if (request.getParameter("statOFF") != null)
      out.println("<p><font color=#DB1260 size=4><i>Stats turned OFF</i></font>");
    else
    if (request.getParameter("statON") != null)
      out.println("<p><font color=#DB1260 size=4><i>Stats turned ON</i></font>");
    else
    if (jarName == null)
      out.println(
        "<p><font color=#DB1260 size=4><i>Select the archive name</i></font>");
    else
    if (prop == null)
      out.println(
        "<p><font color=#DB1260 size=4><i>No stats available (" +
        (jh.toStat ? "set" : "not set") + ")</i></font>");
    out.println(
      "<hr>Alexis Grandemange (c) 2000-2001 GNU LGPL 2.1</body></html>");
    out.flush();
  }
  public String getServletInfo() {
    return "JSPservletPkg.ServletStat Information";
  }
}
